rem @echo off

REM converting %APPROOT% first to it's short form

if "%~1"=="" (

	SET APPROOT=C:\PROGRA~1\IBM\edge

) else (
	if EXIST "%~1" (
		set APPROOT=%~s1
	) else (
		echo "Directory does not exist"
		exit 1
	)
)

FOR /F "tokens=*" %%A IN ('VER') DO SET WinVer=%%A
FOR %%A IN (%WinVer%) DO SET WinVer=%%A
SET WinVer=%WinVer:]=%
SET 4.=Windows NT 4
SET 5.00.=Windows 2000
SET 5.1.=Windows XP
SET 5.2.=Windows Server 2003
SET 6.0.6001=Windows Vista
SET 6.0.6002=Windows Server 2008
SET 6.1.=Windows 7 or Windows Server 2008 R2
FOR /L %%A IN (4,1,6) DO (
	FOR /F "tokens=1,2 delims==" %%B IN ('SET %%A.') DO (
		IF %WinVer% GEQ %%B (
			SET WinVerTxt=%%C
		)
	)
)

rem Locale settings

START /W REGEDIT /E %Temp%.\international.reg "HKEY_CURRENT_USER\Control Panel\International"
FOR /F "tokens=1* delims==" %%A IN ('TYPE %Temp%.\international.reg ^| FIND "Locale"') DO SET Locale=%%B
if /I "%WinVerTxt%"=="Windows 7 or Windows Server 2008 R2" (
	if %Locale% == "de-DE" (
		set lang=de_DE
	) else if %Locale% == "es-ES" (
		set lang=es_ES
	) else if %Locale% == "fr-FR" (
		set lang=fr_FR
	) else if %Locale% == "it-IT" (
		set lang=it_IT
	) else if %Locale% == "ko-KR" (
		set lang=ko_KR
	) else if %Locale% == "ja-JP" (
		set lang=ja_JP
	) else if %Locale% == "pl-PL" (
		set lang=pl_PL
	) else if %Locale% == "cs-CZ" (
		set lang=cs_CZ
	) else if %Locale% == "hu-HU" (
		set lang=hu_HU
	) else if %Locale% == "zh-TW" (
		set lang=zh_TW
	) else if %Locale% == "ru-RU" (
		set lang=ru_RU
	) else if %Locale% == "pt-BR" (
		set lang=pt_BR
	) else if %Locale% == "zh-CN" (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
) else (
	SET Locale=%Locale:"=%
	set /a dec=0x%Locale%
	if "%dec%" == 1031 (
		set lang=de_DE
	) else if "%dec%" == 1034 (
		set lang=es_ES
	) else if "%dec%" == 1036 (
		set lang=fr_FR
	) else if "%dec%" == 1040 (
		set lang=it_IT
	) else if "%dec%" == 1042 (
		set lang=ko_KR
	) else if "%dec%" == 1041 (
		set lang=ja_JP
	) else if "%dec%" == 1045 (
		set lang=pl_PL
	) else if "%dec%" == 1029 (
		set lang=cs_CZ
	) else if "%dec%" == 1038 (
		set lang=hu_HU
	) else if "%dec%" == 1028 (
		set lang=zh_TW
	) else if "%dec%" == 1049 (
		set lang=ru_RU
	) else if "%dec%" == 1046 (
		set lang=pt_BR
	) else if "%dec%" == 2052 (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
)

set cp_service="IBM Caching Proxy"

sc query %cp_service% | find /I "STATE : 4"
if "%ERRORLEVEL%"=="0" (
	net stop %cp_service%
	sc delete "IBM Caching Proxy"
)

REM backing up configuration files

if not EXIST %APPROOT%\oldfiles mkdir %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\ibmproxy.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\ibmproxy.conf %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\rca.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\rca.conf %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\socks.conf.exp xcopy /Y/I %APPROOT%\cp\etc\%lang%\socks.conf.exp %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\pac.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\pac.conf %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\paccp.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\paccp.conf %APPROOT%\oldfiles
if EXIST %APPROOT%\cp\etc\%lang%\pacpolicy.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\pacpolicy.conf %APPROOT%\oldfiles
if NOT EXIST %APPROOT%\oldfiles\protect mkdir %APPROOT%\oldfiles\protect
if EXIST %APPROOT%\cp\server_root\protect xcopy /Y/I/E/H %APPROOT%\cp\server_root\protect\* %APPROOT%\oldfiles\protect


if "%WinVerTxt%"=="Windows NT 4" (
	sc delete "IbmIcsPerf"
	if %ERRORLEVEL% NEQ 0 exit %ERRORLEVEL%
	%SYSTEMROOT%/System32/unlodctr.exe IcsPerfm
)

REM clean service/registry

sc delete "IBM Caching Proxy"

set key="HKLM\SOFTWARE\IBM\WSES-Admin"
reg delete %key% /f
set key="HKLM\SOFTWARE\IBM\WSES-ICU"
reg delete %key% /f
set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy"
reg delete %key% /f
set key="HKLM\SOFTWARE\IBM\WSES-Documentation"
reg delete %key% /f

REM deleting shortcuts

if exist %SYSTEMROOT%\inf\009\IbmIcsPerf\icsperfm.ini.LNK del /f /q %SYSTEMROOT%\inf\009\IbmIcsPerf\icsperfm.ini.LNK
if exist %SYSTEMROOT%\inf\inc\IbmIcsPerf\icsperfm.h.LNK del /f /q %SYSTEMROOT%\inf\inc\IbmIcsPerf\icsperfm.h.LNK

REM PATH reverting changes

echo %PATH% > %TEMP%\curr_path.txt

echo Const ForReading = 1  > %TEMP%\find_replace.vbs  
echo Const ForWriting = 2  >> %TEMP%\find_replace.vbs
echo strFileName = Wscript.Arguments(0) >> %TEMP%\find_replace.vbs
echo strOldText = Wscript.Arguments(1) >> %TEMP%\find_replace.vbs 
echo strNewText = Wscript.Arguments(2) >> %TEMP%\find_replace.vbs 
echo Set objFSO = CreateObject("Scripting.FileSystemObject") >> %TEMP%\find_replace.vbs
echo Set objFile = objFSO.OpenTextFile(strFileName, ForReading) >> %TEMP%\find_replace.vbs
echo strText = objFile.ReadAll >> %TEMP%\find_replace.vbs
echo objFile.Close >> %TEMP%\find_replace.vbs
echo strNewText = Replace(strText, strOldText, strNewText) >> %TEMP%\find_replace.vbs
echo Set objFile = objFSO.OpenTextFile(strFileName, ForWriting) >> %TEMP%\find_replace.vbs
echo objFile.WriteLine strNewText >> %TEMP%\find_replace.vbs
echo objFile.Close >> %TEMP%\find_replace.vbs

cscript /B %TEMP%\find_replace.vbs %TEMP%\curr_path.txt "%APPROOT%\icu\lib;" ""
cscript /B %TEMP%\find_replace.vbs %TEMP%\curr_path.txt "%APPROOT%\admin\platform\bin;" ""
cscript /B %TEMP%\find_replace.vbs %TEMP%\curr_path.txt "%APPROOT%\cp\lib\plugins\pac" ""
cscript /B %TEMP%\find_replace.vbs %TEMP%\curr_path.txt "%APPROOT%\cp\Bin" ""

FOR /F "tokens=* delims=*" %%A IN ('TYPE %Temp%.\curr_path.txt') DO SET NEWPATH=%%A

del /Q %TEMP%\curr_path.txt
del /Q %TEMP%\find_replace.vbs

REM notice that - overwriting PATH with no prompt !

set key="HKLM\SYSTEM\ControlSet001\Control\Session Manager\Environment"
reg add %key% /v PATH /t REG_EXPAND_SZ /d "%NEWPATH%" /f
reg delete %key% /v NLSPATH /f

set key="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment"
reg add %key% /v PATH /t REG_EXPAND_SZ /d "%NEWPATH%" /f
